#include <iostream>
#include <boost/ref.hpp>
#include <boost/thread.hpp>

static boost::recursive_mutex s_mutex;
static boost::barrier s_lockMoveBarrier(2);

void thread_fun1(boost::recursive_mutex::scoped_lock& lock_)
{
   //boost::recursive_mutex::scoped_lock testLock(s_mutex); // uncommenting this causes deadlock, as expected

   std::cout << "in `void thread_fun1(...)`: moving lock...";
   boost::recursive_mutex::scoped_lock lock2(boost::move(lock_));
   std::cout << "done" << std::endl;
   s_lockMoveBarrier.wait();
   std::cout << "in `void thread_fun1(...)`: after the barrier" << std::endl;
}

int main()
{
   boost::recursive_mutex::scoped_lock lock(s_mutex);
   std::cout << "in `int main()`: lock on `s_mutex` acquired" << std::endl;
   boost::thread(&thread_fun1, boost::ref(lock));
   s_lockMoveBarrier.wait();
   std::cout << "in `int main()`: after the barrier" << std::endl;
}
